//
// laz_misc.h- Miscellaneous declarations that really don't belong in q_shared.h...
//

//
// MD2 format info
//
typedef struct
{
	int		ident;
	int		version;

	int		skinwidth;
	int		skinheight;
	int		framesize;	// byte size of each frame

	int		num_skins;
	int		num_xyz;
	int		num_st;		// greater than num_xyz for seams
	int		num_tris;
	int		num_glcmds;	// dwords in strip/fan command list
	int		num_frames;

	int		ofs_skins;	// each skin is a MAX_SKINNAME string
	int		ofs_st;		// byte offset from start for stverts
	int		ofs_tris;	// offset for dtriangles
	int		ofs_frames;	// offset for first frame
	int		ofs_glcmds;	
	int		ofs_end;	// end of file

} dmdl_t;

//
// Footstep enum
//
typedef enum
{
FOOTSTEP_METAL1,
FOOTSTEP_METAL2,
FOOTSTEP_METAL3,
FOOTSTEP_METAL4,
FOOTSTEP_DIRT1,
FOOTSTEP_DIRT2,
FOOTSTEP_DIRT3,
FOOTSTEP_DIRT4,
FOOTSTEP_VENT1,
FOOTSTEP_VENT2,
FOOTSTEP_VENT3,
FOOTSTEP_VENT4,
FOOTSTEP_GRATE1,
FOOTSTEP_GRATE2,
FOOTSTEP_GRATE3,
FOOTSTEP_GRATE4,
FOOTSTEP_TILE1,
FOOTSTEP_TILE2,
FOOTSTEP_TILE3,
FOOTSTEP_TILE4,
FOOTSTEP_GRASS1,
FOOTSTEP_GRASS2,
FOOTSTEP_GRASS3,
FOOTSTEP_GRASS4,
FOOTSTEP_SNOW1,
FOOTSTEP_SNOW2,
FOOTSTEP_SNOW3,
FOOTSTEP_SNOW4,
FOOTSTEP_CARPET1,
FOOTSTEP_CARPET2,
FOOTSTEP_CARPET3,
FOOTSTEP_CARPET4,
FOOTSTEP_FORCE1,
FOOTSTEP_FORCE2,
FOOTSTEP_FORCE3,
FOOTSTEP_FORCE4,
FOOTSTEP_GRAVEL1,
FOOTSTEP_GRAVEL2,
FOOTSTEP_GRAVEL3,
FOOTSTEP_GRAVEL4,
FOOTSTEP_ICE1,
FOOTSTEP_ICE2,
FOOTSTEP_ICE3,
FOOTSTEP_ICE4,
FOOTSTEP_SAND1,
FOOTSTEP_SAND2,
FOOTSTEP_SAND3,
FOOTSTEP_SAND4,
FOOTSTEP_WOOD1,
FOOTSTEP_WOOD2,
FOOTSTEP_WOOD3,
FOOTSTEP_WOOD4,
FOOTSTEP_SLOSH1,
FOOTSTEP_SLOSH2,
FOOTSTEP_SLOSH3,
FOOTSTEP_SLOSH4,
FOOTSTEP_WADE1,
FOOTSTEP_WADE2,
FOOTSTEP_WADE3,
FOOTSTEP_WADE4,
FOOTSTEP_MUD_WADE1,
FOOTSTEP_MUD_WADE2,
FOOTSTEP_LADDER1,
FOOTSTEP_LADDER2,
FOOTSTEP_LADDER3,
FOOTSTEP_LADDER4
} footstep_t;

//
// Entity ID enum
//
typedef enum
{
ENTITY_DONT_USE_THIS_ONE,
ENTITY_ITEM_HEALTH,
ENTITY_ITEM_HEALTH_SMALL,
ENTITY_ITEM_HEALTH_LARGE,
ENTITY_ITEM_HEALTH_MEGA,
ENTITY_INFO_PLAYER_START,
ENTITY_INFO_PLAYER_DEATHMATCH,
ENTITY_INFO_PLAYER_COOP,
ENTITY_INFO_PLAYER_INTERMISSION,
ENTITY_FUNC_PLAT,
ENTITY_FUNC_PLAT2,
ENTITY_FUNC_BUTTON,
ENTITY_FUNC_DOOR,
ENTITY_FUNC_DOOR_SECRET,
ENTITY_FUNC_DOOR_SECRET2,
ENTITY_FUNC_DOOR_ROTATING,
ENTITY_FUNC_ROTATING,
ENTITY_FUNC_TRAIN,
ENTITY_FUNC_WATER,
ENTITY_FUNC_CONVEYOR,
ENTITY_FUNC_AREAPORTAL,
ENTITY_FUNC_CLOCK,
ENTITY_FUNC_WALL,
ENTITY_FUNC_OBJECT,
ENTITY_FUNC_TIMER,
ENTITY_FUNC_EXPLOSIVE,
ENTITY_FUNC_BREAKAWAY,
ENTITY_FUNC_KILLBOX,
ENTITY_TARGET_ACTOR,
ENTITY_TARGET_ANIMATION,
ENTITY_TARGET_BLASTER,
ENTITY_TARGET_CHANGELEVEL,
ENTITY_TARGET_CHARACTER,
ENTITY_TARGET_CROSSLEVEL_TARGET,
ENTITY_TARGET_CROSSLEVEL_TRIGGER,
ENTITY_TARGET_EARTHQUAKE,
ENTITY_TARGET_EXPLOSION,
ENTITY_TARGET_GOAL,
ENTITY_TARGET_HELP,
ENTITY_TARGET_LASER,
ENTITY_TARGET_MAL_LASER,
ENTITY_TARGET_LIGHTRAMP,
ENTITY_TARGET_SECRET,
ENTITY_TARGET_SPAWNER,
ENTITY_TARGET_SPEAKER,
ENTITY_TARGET_SPLASH,
ENTITY_TARGET_STRING,
ENTITY_TARGET_TEMP_ENTITY,
ENTITY_TRIGGER_ALWAYS,
ENTITY_TRIGGER_COUNTER,
ENTITY_TRIGGER_ELEVATOR,
ENTITY_TRIGGER_GRAVITY,
ENTITY_TRIGGER_HURT,
ENTITY_TRIGGER_KEY,
ENTITY_TRIGGER_ONCE,
ENTITY_TRIGGER_MONSTERJUMP,
ENTITY_TRIGGER_MULTIPLE,
ENTITY_TRIGGER_PUSH,
ENTITY_TRIGGER_RELAY,
ENTITY_VIEWTHING,
ENTITY_WORLDSPAWN,
ENTITY_LIGHT,
ENTITY_LIGHT_MINE1,
ENTITY_LIGHT_MINE2,
ENTITY_INFO_NOTNULL,
ENTITY_PATH_CORNER,
ENTITY_POINT_COMBAT,
ENTITY_MISC_EXPLOBOX,
ENTITY_MISC_BANNER,
ENTITY_MISC_SATELLITE_DISH,
ENTITY_MISC_ACTOR,
ENTITY_MISC_GIB_ARM,
ENTITY_MISC_GIB_LEG,
ENTITY_MISC_GIB_HEAD,
ENTITY_MISC_INSANE,
ENTITY_MISC_DEADSOLDIER,
ENTITY_MISC_VIPER,
ENTITY_MISC_CRASHVIPER,
ENTITY_MISC_VIPER_BOMB,
ENTITY_MISC_BIGVIPER,
ENTITY_MISC_STROGG_SHIP,
ENTITY_MISC_TELEPORTER,
ENTITY_MISC_TELEPORTER_DEST,
ENTITY_MISC_BLACKHOLE,
ENTITY_MISC_EASTERTANK,
ENTITY_MISC_EASTERCHICK,
ENTITY_MISC_EASTERCHICK2,
ENTITY_MONSTER_BERSERK,
ENTITY_MONSTER_GLADIATOR,
ENTITY_MONSTER_GUNNER,
ENTITY_MONSTER_INFANTRY,
ENTITY_MONSTER_SOLDIER_LIGHT,
ENTITY_MONSTER_SOLDIER,
ENTITY_MONSTER_SOLDIER_SS,
ENTITY_MONSTER_TANK,
ENTITY_MONSTER_MEDIC,
ENTITY_MONSTER_FLIPPER,
ENTITY_MONSTER_CHICK,
ENTITY_MONSTER_PARASITE,
ENTITY_MONSTER_FLYER,
ENTITY_MONSTER_BRAIN,
ENTITY_MONSTER_FLOATER,
ENTITY_MONSTER_HOVER,
ENTITY_MONSTER_MUTANT,
ENTITY_MONSTER_SUPERTANK,
ENTITY_MONSTER_BOSS2,
ENTITY_MONSTER_BOSS3_STAND,
ENTITY_MONSTER_JORG,
ENTITY_MONSTER_COMMANDER_BODY,
ENTITY_TURRET_BREACH,
ENTITY_TURRET_BASE,
ENTITY_TURRET_DRIVER,
ENTITY_CRANE_BEAM,
ENTITY_CRANE_HOIST,
ENTITY_CRANE_HOOK,
ENTITY_CRANE_CONTROL,
ENTITY_CRANE_RESET,
ENTITY_FUNC_BOBBINGWATER,
ENTITY_FUNC_DOOR_SWINGING,
ENTITY_FUNC_FORCE_WALL,
ENTITY_FUNC_MONITOR,
ENTITY_FUNC_PENDULUM,
ENTITY_FUNC_PIVOT,
ENTITY_FUNC_PUSHABLE,
ENTITY_FUNC_REFLECT,
ENTITY_FUNC_TRACKCHANGE,
ENTITY_FUNC_TRACKTRAIN,
ENTITY_FUNC_TRAINBUTTON,
ENTITY_FUNC_VEHICLE,
ENTITY_HINT_PATH,
ENTITY_INFO_TRAIN_START,
ENTITY_MISC_LIGHT,
ENTITY_MODEL_SPAWN,
ENTITY_MODEL_TRAIN,
ENTITY_MODEL_TURRET,
ENTITY_MONSTER_MAKRON,
ENTITY_PATH_TRACK,
ENTITY_TARGET_ANGER,
ENTITY_TARGET_ATTRACTOR,
ENTITY_TARGET_CD,
ENTITY_TARGET_CHANGE,
ENTITY_TARGET_CLONE,
ENTITY_TARGET_EFFECT,
ENTITY_TARGET_FADE,
ENTITY_TARGET_FAILURE,
ENTITY_TARGET_FOG,
ENTITY_TARGET_FOUNTAIN,
ENTITY_TARGET_LIGHTSWITCH,
ENTITY_TARGET_LOCATOR,
ENTITY_TARGET_LOCK,
ENTITY_TARGET_LOCK_CLUE,
ENTITY_TARGET_LOCK_CODE,
ENTITY_TARGET_LOCK_DIGIT,
ENTITY_TARGET_MONITOR,
ENTITY_TARGET_MONSTERBATTLE,
ENTITY_TARGET_MOVEWITH,
ENTITY_TARGET_PRECIPITATION,
ENTITY_TARGET_ROCKS,
ENTITY_TARGET_ROTATION,
ENTITY_TARGET_SET_EFFECT,
ENTITY_TARGET_SKILL,
ENTITY_TARGET_SKY,
ENTITY_TARGET_PLAYBACK,
ENTITY_TARGET_TEXT,
ENTITY_THING,
ENTITY_TREMOR_TRIGGER_MULTIPLE,
ENTITY_TRIGGER_BBOX,
ENTITY_TRIGGER_DISGUISE,
ENTITY_TRIGGER_FOG,
ENTITY_TRIGGER_INSIDE,
ENTITY_TRIGGER_LOOK,
ENTITY_TRIGGER_MASS,
ENTITY_TRIGGER_SCALES,
ENTITY_TRIGGER_SPEAKER,
ENTITY_TRIGGER_SWITCH,
ENTITY_TRIGGER_TELEPORTER,
ENTITY_TRIGGER_TRANSITION,
ENTITY_BOLT,
ENTITY_DEBRIS,
ENTITY_GIB,
ENTITY_GIBHEAD,
ENTITY_GRENADE,
ENTITY_HANDGRENADE,
ENTITY_ROCKET,
ENTITY_CHASECAM,
ENTITY_CAMPLAYER,
ENTITY_PLAYER_NOISE,
// CUSTOM
ENTITY_SHOCK_SPHERE,
ENTITY_NBOMB,
ENTITY_MONSTER_DOG,
ENTITY_MONSTER_VULTURE,
ENTITY_MONSTER_COCO_MONKEY,
ENTITY_MONSTER_PIERRE_MONKEY1,
ENTITY_MONSTER_PIERRE_MONKEY2,
ENTITY_MONSTER_PIERRE_MONKEY3,
ENTITY_LIGHT_TORCH,
ENTITY_LIGHT_FLAME,
ENTITY_LIGHT_FLAME_CM,
ENTITY_MISC_SICK_GUARD,
ENTITY_MISC_GEKK_WRITHE,
ENTITY_TARGET_COMMAND,
ENTITY_TARGET_GLOBAL_TEXT,
// Xatrix
ENTITY_MONSTER_GEKK,
ENTITY_MONSTER_BRAIN_BETA,
ENTITY_MONSTER_CHICK_HEAT,
ENTITY_MONSTER_GLADIATOR_BETA,
ENTITY_MONSTER_SOLDIER_RIPPER,
ENTITY_MONSTER_SOLDIER_HYPERGUN,
ENTITY_MONSTER_SOLDIER_LASER,
ENTITY_MONSTER_SUPERTANK_BETA,
ENTITY_ION,
ENTITY_PLASMA,
ENTITY_TRAP,
ENTITY_LOOGIE,
ENTITY_MISC_VIPER_MISSILE,
ENTITY_MISC_TRANSPORT,
ENTITY_MISC_AMB4,
ENTITY_ROTATING_LIGHT,
ENTITY_OBJECT_REPAIR,
ENTITY_ITEM_FOODCUBE,
// Rogue
ENTITY_INFO_PLAYER_COOP_LAVA,
ENTITY_FUNC_DM_WALL,
ENTITY_TRIGGER_TELEPORT,
ENTITY_TARGET_STEAM,
ENTITY_TARGET_KILLPLAYERS,
ENTITY_TARGET_BLACKLIGHT,
ENTITY_TARGET_ORB,
ENTITY_TURRET_INVISIBLE_BRAIN,
ENTITY_MONSTER_MEDIC_COMMANDER,
ENTITY_MONSTER_DAEDALUS,
ENTITY_MONSTER_FLYER_KAMIKAZE,
ENTITY_STALKER,
ENTITY_MONSTER_CARRIER,
ENTITY_MONSTER_WIDOW,
ENTITY_MONSTER_WIDOW2,
ENTITY_MONSTER_TURRET,
ENTITY_TURRET_WALL,
ENTITY_BOLT2,
ENTITY_FLECHETTE,
ENTITY_TRACKER,
ENTITY_MINE_PROX,
ENTITY_MINE_TESLA,
ENTITY_FLAMEBURST,
ENTITY_INCENDIARY_GRENADE,
ENTITY_NUKE,
ENTITY_SPHERE_DEFENDER,
ENTITY_SPHERE_VENGEANCE,
ENTITY_SPHERE_HUNTER,
ENTITY_DOPPLEGANGER,
ENTITY_TAGTOKEN,
ENTITY_MISC_NUKE_CORE,
ENTITY_MISC_NUKE,
// Knightmare added
ENTITY_PROX_FIELD,
ENTITY_MONSTER_GUNNER_TACTICIAN,
// Zaero
ENTITY_FUNC_BARRIER,
ENTITY_TRIGGER_LASER,
ENTITY_MONSTER_SENTIEN,
ENTITY_MONSTER_HANDLER,
ENTITY_MONSTER_HOUND,
ENTITY_MONSTER_ZBOSS,
ENTITY_MONSTER_AUTOCANNON,
ENTITY_MISC_SECURITYCAMERA,
ENTITY_MISC_CRATE,
ENTITY_MISC_SEAT,
ENTITY_MISC_COMMDISH,
ENTITY_Z_PLASMASHIELD,
ENTITY_Z_FLARE,
ENTITY_Z_TBOMB,
ENTITY_Z_EMPNUKECENTER,
// LMSP
ENTITY_MONSTER_SOLDIER_PLASMA_BOUNCE,
ENTITY_MONSTER_SOLDIER_PLASMA_SPREAD,
ENTITY_PLASMABALL,
// Q1
ENTITY_MONSTER_Q1_CHTHON,
ENTITY_MONSTER_Q1_DOG,
ENTITY_MONSTER_Q1_ENFORCER,
ENTITY_MONSTER_Q1_FIEND,
ENTITY_MONSTER_Q1_GRUNT,
ENTITY_MONSTER_Q1_HKNIGHT,
ENTITY_MONSTER_Q1_KNIGHT,
ENTITY_MONSTER_Q1_OGRE,
ENTITY_MONSTER_Q1_ROTFISH,
ENTITY_MONSTER_Q1_SCRAG,
ENTITY_MONSTER_Q1_SHALRATH,
ENTITY_MONSTER_Q1_SHAMBLER,
ENTITY_MONSTER_Q1_TARBABY,
ENTITY_MONSTER_Q1_ZOMBIE,
ENTITY_MONSTER_Q1_SHUB,
ENTITY_Q1_TELEPORT_TRAIN,
ENTITY_Q1_NAIL,
ENTITY_Q1_LASER,
ENTITY_Q1_HKNIGHT_FLAME,
ENTITY_Q1_GRENADE,
ENTITY_Q1_ROCKET,
ENTITY_Q1_FIREPOD,
ENTITY_Q1_LAVABALL,
ENTITY_Q1_ACIDBOLT,
ENTITY_Q1_ZOMBIE_GIB,
ENTITY_MISC_Q1_ZOMBIE_CRUCIFIED,
ENTITY_Q1_BUBBLE,
ENTITY_MISC_Q1_BUBBLE_SPAWNER,
ENTITY_MISC_Q1_GLOBE,
ENTITY_MISC_Q1_FLAME_SMALL,
ENTITY_MISC_Q1_FLAME_LARGE,
ENTITY_MISC_Q1_TORCH,
ENTITY_TARGET_Q1_TRAPSHOOTER,
ENTITY_MISC_Q1_EXPLOBOX,
ENTITY_Q1_FIREBALL,
ENTITY_MISC_Q1_FIREBALL_SPAWNER,
ENTITY_MONSTER_Q1_FREDDIE,
} entity_id;
